//
// File: CAI.h
// Created by: berny <2berny@seznam.cz>
// Created on: Mon Aug  4 09:24:32 2003
//

#ifndef _CAI_H_
#define _CAI_H_

#include <pthread.h>
#include "Global.h"

#define _AWARY_MULTITHREAD_

class CGameControl;
/*
	Trida, podle ktere se bude psat ruzna inteligence
	Tady ta je jen virtualni
   Sama implementuje inteligenci random

	pro pouziti na napovedu a podobne lze uzit GetCell(..),
   ale pozor CAI NEmusi vracet ani POVOLENY tah!!
   tah se musi pred provedenim otestovat na platny!!
*/

class CAI
{
	public:
		CAI(CGameControl *gc); // potomek volat musi :-)
		virtual ~CAI();
	
		// CAI interface
	
	 	// volano z hlavni hry - predpoklada, ze vysledek se vrati..
		virtual void TryMove(); // mel by volat i potomek
	
	
		// z hlavni hry je potreba obcas udelat tick, aby se mohlo testovat ukonceni threatu, kdyby se nahodou pouzivaly
		virtual void TimerTick(); // nemel by volat potomek
		
		// zda AI bude chtit vstup uzivatele
		virtual bool WantUserInput();      // nemel by volat potomek
		virtual void UserInput(int field); // nemel by volat potomek

		// vrati cellik, kam si inteligence mysli, ze by se melo hrat
		// nepracuje s internim stavem, aby bylo mozne volat zvenku
		// v AI by se mohlo poustet ve vlastnim vlakne, aby aplikace netuhla
		// musi byt udelane tak, aby slo volat i v jinem vlaknu!!! - to znamena, 
		// ze by melo z objektu maximalne tak cist sve nastaveni, ale ne toho moc
		// menit.
		virtual int GetCell(const st_game_status  *status); // nemel by volat potomek
		// provede volani s   m_status
		virtual int GetCell(); // nemel by volat potomek
		
		// vraci, zda jsme zrovna na tahu
		bool IsPlaying() { return m_playing; }
	
	protected:

		static void* AIthread(void *arg);
		
		// CAI variables
		CGameControl   *m_gc;      // ukazatel na hru
		bool            m_playing; // zda zrovna jsme na tahu
		st_game_status  m_status;  // sice muzeme kdykoliv zjistit z m_gc, ale lepsi mit vlastni kopii
	
		// pro praci s vlakny - vypocet tahu bezi v jinem vlaknu, nez UI - user interface
		// tyto promene muze vlakno menit
		pthread_t       m_thread;          // vlakno prave promyslene
		bool            m_thread_active;   // pro praci s vlakny
	
};


#endif	//_CAI_H_
