//
// File: CAIAB.h
// Created by: berny <berny@seznam.cz>
// Created on: Sun Aug 17 08:58:26 2003
//

#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include "CAIAB.h"
#include "Global.h"


CAIAB::CAIAB(CGameControl *gc, int depth) : CAI(gc)
{
	assert(depth > 0);
	
	m_depth = depth;
}


CAIAB::~CAIAB()
{
	
}


// vrati cellik, kam si inteligence mysli, ze by se melo hrat
// nepracuje s internim stavem, aby bylo mozne volat zvenku
int CAIAB::GetCell(const st_game_status  *status)
{
	assert( status != NULL );
	
	m_reccalls = 0;
	m_player = status->player;
	if ( m_player == 1 ) m_opponent = 0;
	else m_opponent = 1;
		
	int move;
	int score = RecursivTest(status, m_depth, &move, 10000, -10000);
	
	printf("rekurzivnich volani : %d, score %d\n", m_reccalls, score);
	
	return move; 
}
// vrati nelepsi mozny tah - pouziva se rekurzivne - max_score rozhoduje, zda se bude
// vybirat maximum nebo minimum, v move vraci, ktery tah ono maximum / minimum dosahl - muze byt NULL
// a,b pri prozeravani : a == minimum, b == maximum
int CAIAB::RecursivTest(const st_game_status  *status, int depth, int *move, int a, int b)
{
	assert( status != NULL);
	
	m_reccalls++;
	
	// konec zanorovani
	if ( depth == 0 || gsGameEnded(status) ) return Score(status);
	
	// inicializace
	bool max = ( status->player == m_player ); // zda budeme hledat maximum nebo minimum
	
	int s, m = 0;  // s == score, m == move
	if ( max ) s = -10000;
	else s = 10000;

	// vyzkousime vsechny tahy a vybereme ten s nejlepsim score
	for ( int i = 1; i <= status->cells; i++ ) {
		st_game_status st = *status;
		if ( gsMakeMoveCheck(&st, i) ) { // zkusime provest tah a zhodnotime, jak dopad
			int score = RecursivTest(&st, depth-1, NULL, a, b);
			
			if ( max ) {
				if ( score > s ) {
					s = score;
					m = i;
					// prorezavani
					if ( s > a ) break;
					if ( s > b ) b = s;
				}
			} else {
				if ( score < s ) {
					s = score;
					m = i;
					// prorezavani
					if ( s < b ) break;
					if ( s < a ) a = s;
				}
			}
	
			// otestujeme a pridame trochu nahodnosti - staci jen v prvni hladine
			if ( m_depth == depth && score == s && rand()%2 == 0 )  { 
				m = i;
			}
		}
	}
	
	if ( move != NULL ) *move = m;
	return s;
}

// ohodnoti tah  status poro hrace m_player
int CAIAB::Score(const st_game_status  *status)
{
	return status->field[m_player][0] -  status->field[m_opponent][0];
}
