//
// File: CAIAB.h
// Created by: berny <berny@seznam.cz>
// Created on: Sun Aug 17 08:58:26 2003
//

#ifndef _CAIAB_H_
#define _CAIAB_H_

#include "CAI.h"

class CGameControl;

/*
	Inteligence s prohledavanim do hloubky a alpha beta prorezavanim
   heuristiku nema, protoze me zadna nenapadla :-)
*/
class CAIAB : public CAI
{
	public:
		CAIAB(CGameControl *gcm, int depth);
		~CAIAB();
	
		// CAIAB interface
	
		// vrati cellik, kam si inteligence mysli, ze by se melo hrat
		// nepracuje s internim stavem, aby bylo mozne volat zvenku
		virtual int GetCell(const st_game_status  *status);
	
	protected:
		// CAIAB variables
		int m_depth;   // hloubka, do ktere se bude prohledavat
		int m_player;   // nas hrac - pri kazdem GetCell se nastavuje - kuli ohodnnoceni
		int m_opponent; // protihrac - pri kazdem GetCell se nastavuje - kuli ohodnnoceni
	
		int m_reccalls; // pocet rekurzivnich zavolani - je spis pro zajimavost
	
		// ohodnoti tah  status poro hrace m_player
		int Score(const st_game_status  *status);
	
		// vrati nelepsi mozny tah - pouziva se rekurzivne - max_score rozhoduje, zda se bude
		// vybirat maximum nebo minimum, v move vraci, ktery tah ono maximum / minimum dosahl - muze byt NULL
		// a,b pri prozeravani : a == minimum, b == maximum
		int RecursivTest(const st_game_status  *status, int depth, int *move, int a, int b);
};


#endif	//_CAIAB_H_
