//
// File: CGameControl.h
// Created by: berny <2berny@seznam.cz>
// Created on: Mon Aug  4 09:18:20 2003
//

#ifndef _CGAMECONTROL_H_
#define _CGAMECONTROL_H_

#define GAME_ENDED_NO  0 // hra stale bezi
#define GAME_ENDED_1ST 1 // vyhral 1. hrac
#define GAME_ENDED_2ND 2 // vyhral 2. hrac
#define GAME_ENDED     3 // remiza

#include "Global.h"
#include <ctime>

#include <vector>
using namespace std;

/*
	Ma v sobe stav hry a rozhoduje, kdo bude hrat a jake se budou delat tahy...
*/

class CAI;
class CAIReplay;
	
class CGameControl
{
	public:
		CGameControl();
		 ~CGameControl();
	
		// CGameControl interface
	
		// zacne novou hru - fields == pocet hernich poli, rocks == pocet hernich kamenu v 1 poli
		// pl1 a pl2 jsou jiz nastavene a pripravene inteligence
		// pokud je pl1 a pl2 vytvoreno pomoci new a chceme, aby je hra sama smazala, deleteAI = true
		void NewGame(int fields, int rocks, CAI *pl1, CAI *pl2, bool deleteAI = false); 
	
		// AI vraci vysledek se hry - testujeme, zda nas vola objekt, ktery je skutecne na tahu!!!!
		void AIMoved(int field, const CAI *which); 
	
		// testuje, zda hra zkoncila, pripadne kdo vyhral
		int GameEnded();
	
		// vraci tru, pokud doslo ke zmene hraci plochy od posledniho volani - pouziva se pri prekleslovani
		bool StatusChanged();
	
		// vraci vy hry hry
		st_game_status GetStatus();
	
		// vraci cislo tahu
		int GetTurnsCnt();
	
		//	vraci, kolik casu ktery hrac uz potreboval na svou hru
		double GetTime(int player);
	
		// rika hre, ze je mozne provest dalsi tah - umozni delat mezi tahy pauzu - 2X pocitac - clovek by ze hry videl jen vysledek
		void NextTurn(); 
	
		// zavola TimerTick u inteligenci
		void TimerTick();
	
		// ulozi hru - ukladat lze jen dohrane hry
		bool SaveHistory(char *filename);
	
		// nacte hru a pripravi si inteligence, ktere hraji "replay"
		bool LoadHistory(char *filename);
	
		// zda data jsou platna - vraci m_valid
		bool IsValid();
	
	protected:
		// CGameControl variables
		bool             m_valid; // zda jsou data nize platna
	
		vector<int>      m_gm_history; // seznam tahu, jak se hra hrala
		int              m_gm_cells;   // pocet policek ve hre   -- tohle vsechno slouzi pro "prehravani a zaznam" hry
		int              m_gm_rocks;   // kamenu na policko  
		
		friend class CAIReplay;
		vector<int>      m_gm_loaded;  // kompletni zaznam hry, pokud bylo pouzito LoadHistory(..);
	
		st_game_status   m_status; // aktualni stav hry - sem nesmi mit nikdo pristup, aby nam hraci nepodvadeli :-)
		CAI             *m_AI[2];  // obe dve inteligence
		bool             m_status_changed; // kdyz doslo ke zmene hraci plochy
	
		bool             m_ready_next_move; // je true, pokud je pripraveno k dalsimu tahu
	
		int              m_rocks;  // celkovy pocet kamenu ve hre - kdyz jsou vsechny v domecku => konec hry
	
		int              m_turnscnt; // pocet odehranych tahu - pocita tahy
	
		double           m_time[2]; // kolik milisekund uz ktery z hracu potreboval pro svuj tah
		time_t           m_clockstart; // zacatek mereni casu - pro ucely mereni casu hracu
	
		bool             m_deleteAI; // zda se maji AI na konci deletnout
};


#endif	//_CGAMECONTROL_H_
