#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <assert.h>

#include "gui.h"
#include "tthread.h"

// ////////////////////////////////////////////////////////////////////////// //
//                    Hlavni okno                                             //  
// ////////////////////////////////////////////////////////////////////////// //

GtkWidget *main_window = NULL;
GtkWidget *help_window = NULL;  // mame jako ukazatele, aby neoteviraly stale nova okna
GtkWidget *about_dialog = NULL; 
GtkWidget *new_game_dialog = NULL; 
GtkWidget *setting_dialog = NULL; 

// nejaka implicitni data pro hru
int g_ai1 = AI_HUMAN;
int g_ai2 = AI_RANDOM;
int g_cells = 6;
int g_rocks = 5;



// Zacit hru znovu
void on_za____t_hru_znovu1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	start_new_game();
}

// zacin novou hru
void on_new_game_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	GtkWidget *sb = NULL;
	sb = lookup_widget(main_window, "statusbar");
	gtk_statusbar_push(GTK_STATUSBAR(sb), 0, "Nastaven nov hry...");
	
	new_game_dialog = create_new_game_with_data();
	gtk_widget_show(new_game_dialog);
	
	gtk_statusbar_pop(GTK_STATUSBAR(sb), 0);
}

// Ukloncit
void on_ukon__it1_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	gtk_main_quit();	
}

// Zobrazi about dialog
void on_about1_activate  (GtkMenuItem *menuitem, gpointer user_data)
{
	if ( about_dialog == NULL )
		about_dialog = create_about();
	
	gtk_widget_show(about_dialog);
}

void on_pravidla_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	if ( help_window == NULL )
		help_window = create_help_window();
	
	gtk_widget_show(help_window);
}

void on_window1_destroy (GtkObject *object, gpointer user_data)
{
	// oznamime, ze se zavira aplikace
	clean_game_data();
	
	// zrusi tthread - musi byt AZ ZA clean_game_data !!
	close_tthread(); 
	
	// pri zavreni hlavniho okna ukoncime program. Jak jinak :-)
	gtk_main_quit(); 
}


// ////////////////////////////////////////////////////////////////////////// //
//                    Nova hra dialog                                         //  
// ////////////////////////////////////////////////////////////////////////// //

void on_new_cancel_clicked (GtkButton *button, gpointer user_data)
{
	assert( new_game_dialog != NULL );

	gtk_widget_destroy(new_game_dialog);
}


void on_new_ok_clicked (GtkButton *button, gpointer user_data)
{
	assert( new_game_dialog != NULL );
	
	// Nacteme hodnoty promenych z dialogu
	GtkWidget *w = NULL;
	
	// prvni AI
	w = lookup_widget(new_game_dialog, "optionmenu1"); assert(w != NULL);
	g_ai1 = gtk_option_menu_get_history(GTK_OPTION_MENU (w));
	
	// druha AI
	w = lookup_widget(new_game_dialog, "optionmenu2"); assert(w != NULL);
	g_ai2 = gtk_option_menu_get_history(GTK_OPTION_MENU (w));

	// pocet celliku
	w = lookup_widget(new_game_dialog, "cells"); assert(w != NULL);
	g_cells = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(w));
	
	// pocet kaminku
	w = lookup_widget(new_game_dialog, "rocks"); assert(w != NULL);
	g_rocks = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(w));
	

	// zahajime novou hru
	start_new_game();
	
	// a zavreme dialog nove hry
	gtk_widget_destroy(new_game_dialog);
}

void on_new_game_destroy (GtkObject *object, gpointer user_data)
{
	new_game_dialog = NULL;
}

// ////////////////////////////////////////////////////////////////////////// //
//                    Ostatni                                                 //  
// ////////////////////////////////////////////////////////////////////////// //

void on_about_destroy (GtkObject *object, gpointer user_data)
{
	about_dialog = NULL; // dialog se zavira, takze si odmazneme ukazatel
}

void on_help_window_destroy (GtkObject *object, gpointer user_data)
{
	help_window = NULL;
}

// ///////////////////////////////////////////////// Dialg nastaveni

void on_nastaveni_activate (GtkMenuItem *menuitem, gpointer user_data)
{
	if ( setting_dialog == NULL ) {
		setting_dialog = create_setting_dialog_with_data();
		gtk_widget_show(setting_dialog);
	}
}


void on_autotime_changed (GtkEditable *editable, gpointer user_data)
{
	if ( setting_dialog != NULL ) {
		
		// timeout
		GtkWidget* w = lookup_widget(setting_dialog, "autotime"); assert(w != NULL);
		g_automatic_game_nextturn_timeout = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON (w));
	
		auto_turn();
	}
}


void on_autoturn_toggled (GtkToggleButton *togglebutton, gpointer user_data)
{
	if ( setting_dialog != NULL ) {
		
		// timeout
		GtkWidget* w = lookup_widget(setting_dialog, "autoturn"); assert(w != NULL);
		g_automatic_game_nextturn = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(w));
	
		auto_turn();
	}
}


void on_setting_close_clicked (GtkButton *button, gpointer user_data)
{
	assert ( setting_dialog != NULL );
	
	gtk_widget_destroy(setting_dialog);
}

void on_setting_dialog_destroy (GtkObject *object, gpointer user_data)
{
	setting_dialog = NULL;
}

void
on_stars_toggled                       (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
	if ( setting_dialog != NULL ) {
		
		// timeout
		GtkWidget* w = lookup_widget(setting_dialog, "stars"); assert(w != NULL);
		g_show_stars = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(w));
	
		gui_actualize_game_status();
	}
}
