
// bere vsechny *.h spojene s GUI a dava je do jednoho
// a navic doplnuje dalsi funkce, ktere bylo 
#ifndef _GUI_H_
#define _GUI_H_

#include <gnome.h>

#ifdef __cplusplus
extern "C" {
#endif
	
#include "interface.h"
#include "support.h"
#include "callbacks.h"
	
// tvori hlavni okno jako create_main_window, ale nanic zapoji signaly
// od knofliku tam, kam patri. V gladu to z nejakeho podivneho duvodu
// neslo udelat
GtkWidget* create_main_window_with_conn (void);
// vytvori dialog nove hry a nastavi v nem spravne hodnoty
GtkWidget* create_new_game_with_data(void);
// vytvori dialog nastaveni a nastavi aktualni data
GtkWidget* create_setting_dialog_with_data (void);

	
// Awary specialni callbacky
// poterbujem totiz predavat user_data, coz s Gladem z nejakych zahadnych duvodu nelze :-(

// vola se, kdyz chce nejaky hrac hrat (int)user_data -tym polickem
void on_pl1_clicked (GtkButton *button, gpointer user_data);
void on_pl2_clicked (GtkButton *button, gpointer user_data);
	
// pri prejeti myskou - pro delani "ukazky" noveho stavu
void on_pl_enter (GtkButton *button, gpointer user_data);
void on_pl_leave (GtkButton *button, gpointer user_data);


// specialni funkce pro aktualizaci GUI a pro jeho zmeny
// aktualizuje napisy na knoflikach
void gui_actualize_game_status(); 

// aktualizuje gui - zmeni pocet "buttonku" na cells + pripoji callbacky
void gui_recreate_gamedesk(int cells);

// funkce, ktera se vola, a ocekava platna globalni data
void start_new_game();

// funkce, ktera by se mela volat na konci programu - provadi uklid
void clean_game_data();

// ukazatel na hlavni okno aplikace
extern GtkWidget *main_window;	

// aktualni nastaveni hry - pro dialogy
#define AI_HUMAN  0
#define AI_RANDOM 1
#define AI_EASY   2
#define AI_AB4    3
#define AI_AB8    4
#define AI_AB12   5

extern int g_ai1;
extern int g_ai2;
extern int g_cells;
extern int g_rocks;

extern gboolean g_show_stars; // zda je maji na hraci plose kreslit krome cisel i hvezdicky pro nazornost
extern gboolean g_automatic_game_nextturn; // zda se ma startovat vlakno, ktere po timeoutu zavola gc->NextTurn();
extern int g_automatic_game_nextturn_timeout; // casova prodleva


#ifdef __cplusplus
}
#endif

	
#endif
