// Funkce pro praci vlaknem, ktere se chova jako casovac
// a ktere vola gc->TimerTick(); Vola se jendou za sekundu

#include <unistd.h>
#include <stdio.h>

#include "CGameControl.h"
#include "CAI.h"
#include "tthread.h"

extern CGameControl *gc;
extern CAI *ai1;
extern CAI *ai2;

#include "gui.h"


// /////////////////////////////////////// Casovaci vlakno

pthread_t tthread; // casove vlakno
bool      tthread_finish = false; // pozadavek na ukonceni vlakna
sem_t     g_sem;  // promena semaforu

// Funkce dalsiho vlakna, ktere bezi jako timer
int timer_NextTurn = 200;
void *tthread_function(void *arg)
{
	while ( tthread_finish == false ){
// 	usleep(100000); // 100ms -- zatezuje procesor, takze nee 
		sleep(1); // 1s
		sem_wait(&g_sem);
		
		if (	gc != NULL	) gc->TimerTick();
		
		// musi se vzit zvlast, aby se delalo pod semaforem
		int t = timer_NextTurn;
		timer_NextTurn++;
		
		sem_post(&g_sem);

		if ( t == g_automatic_game_nextturn_timeout && g_automatic_game_nextturn ) {
			on_domecek_clicked(NULL, NULL);
		}
	}
	
	return NULL;
}

// inicializuje vlakno
void inicialize_tthread()
{
	// vytvorime semafor
	if ( sem_init(&g_sem, 0, 1) != 0 ) {
		exit(1);
	}
	
	// vytvorime vlakno
	tthread_finish = false;
	if ( pthread_create(&tthread, NULL, tthread_function, NULL) != 0 ) {
		exit(1);
	}
}

// ukoncuje vlakno i semafor
void close_tthread()
{
	// vlakno casovace
	tthread_finish = true;
	void *result;
	pthread_join(tthread, &result);
	
	// semafor
	sem_destroy(&g_sem);
	
	// vlakno automatickeho hrani pocitace
	g_automatic_game_nextturn = 0;
	auto_turn();
}


// ////////////////////////////////////////// automaticky hraci vlakno

gboolean g_automatic_game_nextturn = 1; // zda se ma startovat vlakno, ktere po timeoutu zavola gc->NextTurn();
int g_automatic_game_nextturn_timeout = 3; // casova prodleva

/* - Tady to uz byl trochu moc "BORDEL"
pthread_t *need_join = NULL; // pokud nejake vlakno potrebuje join

// funkce vlakna
void *auto_turn_t(void* self)
{
	pthread_setcancelstate(PTHREAD_CANCEL_ENABLE, NULL);
	pthread_setcanceltype(PTHREAD_CANCEL_ASYNCHRONOUS, NULL);

	printf("Autoturn waiting\n");	
	
	if ( g_automatic_game_nextturn_timeout >= 0 ) sleep(g_automatic_game_nextturn_timeout);
	
	printf("Autoturn active\n");	
	
	on_domecek_clicked(NULL, NULL);
	need_join = (pthread_t *)self;
	return NULL;
}

// pokud uzivatel chce, tak spustime obsluzne vlakno
// pro next turn
void auto_turn()
{
	static bool thread_waiting = false;
	static pthread_t pt;
	
	if ( need_join ) {
		void* r;
		pthread_join(*need_join, &r);
		delete need_join;
		need_join = NULL;
		thread_running = false;
	}
	
	if ( g_automatic_game_nextturn && (
		  ( ai1->IsPlaying() && !ai1->WantUserInput()) ||
		  ( ai2->IsPlaying() && !ai2->WantUserInput()))) {
	
			if ( thread_running ) pthread_cancel(pt);
			pthread_create(&pt, NULL, auto_turn_t, NULL);
			thread_running = true;
	}
	else 
		if ( thread_running ) {
			pthread_cancel(pt);
			thread_running = false;
		}
}
*/

void auto_turn() 
{
	if ( g_automatic_game_nextturn ) {
		sem_wait(&g_sem);
		timer_NextTurn = 0;
		sem_post(&g_sem);
	}
}
