/*
	Doplnene nektere funkce od Gladu pro ucely jednodusi obsluhy callbacku
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <assert.h>

#include <bonobo.h>


#include "gui.h"

// makro pro pridavani pro lookup_widget(...)
#define GLADE_HOOKUP_OBJECT(component,widget,name) \
    g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)
	 
	 
// tvoreni hlavniho okna
GtkWidget* create_main_window_with_conn (void)
{
	GtkWidget* mw = NULL;
	
	// vytvoreni okna
   mw = create_main_window();
	if ( mw == NULL ) return NULL; // Gtk se stra, aby mw == NULL nikdy nenastalo, ale nam to neuskodi :-)
	
	// pridani callbacku pro 1. hrace
	int j;
	for ( j = 1; j <= 6; j++ ) {
		GtkWidget *gw;
		char s[10];

		// 1. hrac
		sprintf(s, "bpl1_%d", j);
		gw = lookup_widget(mw, s);
		if ( gw != NULL )
			g_signal_connect ((gpointer) gw, "clicked",
                    		    G_CALLBACK (on_pl1_clicked),
                           (gpointer) j);
		// 2. hrac
		sprintf(s, "bpl2_%d", j);
		gw = lookup_widget(mw, s);
		if ( gw != NULL )
			g_signal_connect ((gpointer) gw, "clicked",
                    		    G_CALLBACK (on_pl2_clicked),
                           (gpointer) j);
		
	}
	// konec
	return mw;
}


// pretvoreni hlavniho okna, aby se dal menit pocet knofliku na XX
void gui_recreate_gamedesk(int cells)
{
   GtkWidget *hbuttonbox1; // boxy pro tlacitka
   GtkWidget *hbuttonbox2;
   GtkWidget *button;        // tlacitka od hracu
	char s[10]; // na jmena buttonku
  	
	// nacteni kontejenru na buttonky
	hbuttonbox1 = lookup_widget(main_window, "hbuttonbox1");
	hbuttonbox2 = lookup_widget(main_window, "hbuttonbox2");
	
	assert(hbuttonbox1 != NULL && hbuttonbox2 != NULL); 

	// zruseni starych buttonku
	int i, j;
	for ( j = 1; j <= 2; j++ ) { // pro oba hrace
//		sprintf(s, "hbuttonbox%d", j);
//		GtkWidget* hbbox = lookup_widget(main_window, s);
		i = 1;
		// hledame vsechny buttonky a mazeme je
		while ( 1 ) {
			sprintf(s, "bpl%d_%d", j, i);
			button = lookup_widget(main_window, s);
			if ( button == NULL ) break;
//			gtk_container_remove(GTK_CONTAINER(hbbox), button);
			gtk_widget_destroy(button);
			i++;
		}
	}
	
	
	// pridani buttonku
	for ( i = 1; i <= cells; i++ ) {
		// prvni hrac
		sprintf(s, "bpl1_%d", i);
		button = gtk_button_new_with_mnemonic (_("5"));
		gtk_container_add (GTK_CONTAINER (hbuttonbox1), button);
		GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
		GLADE_HOOKUP_OBJECT (main_window, button, s);
		g_signal_connect ((gpointer) button, "clicked",
                   		    G_CALLBACK (on_pl1_clicked),
                          (gpointer) i);
		g_signal_connect ((gpointer) button, "enter",
                   		    G_CALLBACK (on_pl_enter),
                          (gpointer) i);
		g_signal_connect ((gpointer) button, "leave",
                   		    G_CALLBACK (on_pl_leave), NULL);
		// druhy hrac
		sprintf(s, "bpl2_%d", cells - i + 1);
		button = gtk_button_new_with_mnemonic (_("5"));
		gtk_container_add (GTK_CONTAINER (hbuttonbox2), button);
		GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);
		GLADE_HOOKUP_OBJECT (main_window, button, s);
		g_signal_connect ((gpointer) button, "clicked",
                   		   G_CALLBACK (on_pl2_clicked),
                          (gpointer) cells - i + 1);
		g_signal_connect ((gpointer) button, "enter",
                   		    G_CALLBACK (on_pl_enter),
                          (gpointer) cells - i + 1);
		g_signal_connect ((gpointer) button, "leave",
                   		    G_CALLBACK (on_pl_leave), NULL);
	}
	
	gtk_widget_show_all(main_window);
}

// tvori dialog nove hry a nastavuje v nem data
GtkWidget* create_new_game_with_data(void)
{
	GtkWidget *gw = create_new_game();
	
	GtkWidget *w = NULL;
	
	// prvni AI
	w = lookup_widget(gw, "optionmenu1"); assert(w != NULL);
	gtk_option_menu_set_history (GTK_OPTION_MENU (w), g_ai1);

	// druha AI
	w = lookup_widget(gw, "optionmenu2"); assert(w != NULL);
	gtk_option_menu_set_history (GTK_OPTION_MENU (w), g_ai2);

	// pocet celliku
	w = lookup_widget(gw, "cells"); assert(w != NULL);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(w), g_cells);
	
	// pocet kaminku
	w = lookup_widget(gw, "rocks"); assert(w != NULL);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(w), g_rocks);
	
	return gw;
}

// tvori dialog nastveni a nastavuje v nem data
GtkWidget* create_setting_dialog_with_data(void)
{
	GtkWidget *gw = create_setting_dialog();
	
	GtkWidget *w = NULL;
	
	// timeout
	w = lookup_widget(gw, "autotime"); assert(w != NULL);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON (w), g_automatic_game_nextturn_timeout);

	// zda autoturn pouzivat
	w = lookup_widget(gw, "autoturn"); assert(w != NULL);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(w), g_automatic_game_nextturn);
	
	// zda kreslit hvezdicky
	w = lookup_widget(gw, "stars"); assert(w != NULL);
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(w), g_show_stars);
	return gw;	
}
